/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSWebXRBoundedReferenceSpace.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMPointReadOnly.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebXRBoundedReferenceSpaceConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRBoundedReferenceSpace_boundsGeometry);

class JSWebXRBoundedReferenceSpacePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebXRBoundedReferenceSpacePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebXRBoundedReferenceSpacePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebXRBoundedReferenceSpacePrototype>(vm)) JSWebXRBoundedReferenceSpacePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRBoundedReferenceSpacePrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebXRBoundedReferenceSpacePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRBoundedReferenceSpacePrototype, JSWebXRBoundedReferenceSpacePrototype::Base);

using JSWebXRBoundedReferenceSpaceDOMConstructor = JSDOMConstructorNotConstructable<JSWebXRBoundedReferenceSpace>;

template<> const ClassInfo JSWebXRBoundedReferenceSpaceDOMConstructor::s_info = { "XRBoundedReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRBoundedReferenceSpaceDOMConstructor) };

template<> JSValue JSWebXRBoundedReferenceSpaceDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSWebXRReferenceSpace::getConstructor(vm, &globalObject);
}

template<> void JSWebXRBoundedReferenceSpaceDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRBoundedReferenceSpace"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSWebXRBoundedReferenceSpace::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 2> JSWebXRBoundedReferenceSpacePrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRBoundedReferenceSpaceConstructor, 0 } },
    HashTableValue { "boundsGeometry"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRBoundedReferenceSpace_boundsGeometry, 0 } },
};

const ClassInfo JSWebXRBoundedReferenceSpacePrototype::s_info = { "XRBoundedReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRBoundedReferenceSpacePrototype) };

void JSWebXRBoundedReferenceSpacePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebXRBoundedReferenceSpace::info(), JSWebXRBoundedReferenceSpacePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebXRBoundedReferenceSpace::s_info = { "XRBoundedReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRBoundedReferenceSpace) };

JSWebXRBoundedReferenceSpace::JSWebXRBoundedReferenceSpace(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebXRBoundedReferenceSpace>&& impl)
    : JSWebXRReferenceSpace(structure, globalObject, WTFMove(impl))
{
}

Ref<WebXRBoundedReferenceSpace> JSWebXRBoundedReferenceSpace::protectedWrapped() const
{
    return wrapped();
}

static_assert(!std::is_base_of<ActiveDOMObject, WebXRBoundedReferenceSpace>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSWebXRBoundedReferenceSpace::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSWebXRBoundedReferenceSpacePrototype::createStructure(vm, &globalObject, JSWebXRReferenceSpace::prototype(vm, globalObject));
    structure->setMayBePrototype(true);
    return JSWebXRBoundedReferenceSpacePrototype::create(vm, &globalObject, structure);
}

JSObject* JSWebXRBoundedReferenceSpace::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebXRBoundedReferenceSpace>(vm, globalObject);
}

JSValue JSWebXRBoundedReferenceSpace::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebXRBoundedReferenceSpaceDOMConstructor, DOMConstructorID::WebXRBoundedReferenceSpace>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRBoundedReferenceSpaceConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebXRBoundedReferenceSpacePrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebXRBoundedReferenceSpace::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsWebXRBoundedReferenceSpace_boundsGeometryGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRBoundedReferenceSpace& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLFrozenArray<IDLInterface<DOMPointReadOnly>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.boundsGeometry())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRBoundedReferenceSpace_boundsGeometry, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRBoundedReferenceSpace>::get<jsWebXRBoundedReferenceSpace_boundsGeometryGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

JSC::GCClient::IsoSubspace* JSWebXRBoundedReferenceSpace::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSWebXRBoundedReferenceSpace, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForWebXRBoundedReferenceSpace.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForWebXRBoundedReferenceSpace = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForWebXRBoundedReferenceSpace.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForWebXRBoundedReferenceSpace = std::forward<decltype(space)>(space); }
    );
}

void JSWebXRBoundedReferenceSpace::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebXRBoundedReferenceSpace*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

WebXRBoundedReferenceSpace* JSWebXRBoundedReferenceSpace::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebXRBoundedReferenceSpace*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBXR)
