/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSWebXRReferenceSpace.h"

#include "ActiveDOMObject.h"
#include "EventNames.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSEventListener.h"
#include "JSWebXRReferenceSpace.h"
#include "JSWebXRRigidTransform.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsWebXRReferenceSpacePrototypeFunction_getOffsetReferenceSpace);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebXRReferenceSpaceConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRReferenceSpace_onreset);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebXRReferenceSpace_onreset);

class JSWebXRReferenceSpacePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebXRReferenceSpacePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebXRReferenceSpacePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebXRReferenceSpacePrototype>(vm)) JSWebXRReferenceSpacePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRReferenceSpacePrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebXRReferenceSpacePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRReferenceSpacePrototype, JSWebXRReferenceSpacePrototype::Base);

using JSWebXRReferenceSpaceDOMConstructor = JSDOMConstructorNotConstructable<JSWebXRReferenceSpace>;

template<> const ClassInfo JSWebXRReferenceSpaceDOMConstructor::s_info = { "XRReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRReferenceSpaceDOMConstructor) };

template<> JSValue JSWebXRReferenceSpaceDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSWebXRSpace::getConstructor(vm, &globalObject);
}

template<> void JSWebXRReferenceSpaceDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRReferenceSpace"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSWebXRReferenceSpace::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 3> JSWebXRReferenceSpacePrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRReferenceSpaceConstructor, 0 } },
    HashTableValue { "onreset"_s, JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRReferenceSpace_onreset, setJSWebXRReferenceSpace_onreset } },
    HashTableValue { "getOffsetReferenceSpace"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { HashTableValue::NativeFunctionType, jsWebXRReferenceSpacePrototypeFunction_getOffsetReferenceSpace, 1 } },
};

const ClassInfo JSWebXRReferenceSpacePrototype::s_info = { "XRReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRReferenceSpacePrototype) };

void JSWebXRReferenceSpacePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebXRReferenceSpace::info(), JSWebXRReferenceSpacePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebXRReferenceSpace::s_info = { "XRReferenceSpace"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRReferenceSpace) };

JSWebXRReferenceSpace::JSWebXRReferenceSpace(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebXRReferenceSpace>&& impl)
    : JSWebXRSpace(structure, globalObject, WTFMove(impl))
{
}

Ref<WebXRReferenceSpace> JSWebXRReferenceSpace::protectedWrapped() const
{
    return wrapped();
}

static_assert(!std::is_base_of<ActiveDOMObject, WebXRReferenceSpace>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSWebXRReferenceSpace::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSWebXRReferenceSpacePrototype::createStructure(vm, &globalObject, JSWebXRSpace::prototype(vm, globalObject));
    structure->setMayBePrototype(true);
    return JSWebXRReferenceSpacePrototype::create(vm, &globalObject, structure);
}

JSObject* JSWebXRReferenceSpace::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebXRReferenceSpace>(vm, globalObject);
}

JSValue JSWebXRReferenceSpace::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebXRReferenceSpaceDOMConstructor, DOMConstructorID::WebXRReferenceSpace>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRReferenceSpaceConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebXRReferenceSpacePrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebXRReferenceSpace::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsWebXRReferenceSpace_onresetGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRReferenceSpace& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.protectedWrapped(), eventNames().resetEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRReferenceSpace_onreset, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRReferenceSpace>::get<jsWebXRReferenceSpace_onresetGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline bool setJSWebXRReferenceSpace_onresetSetter(JSGlobalObject& lexicalGlobalObject, JSWebXRReferenceSpace& thisObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    UNUSED_PARAM(vm);
    setEventHandlerAttribute<JSEventListener>(thisObject.protectedWrapped(), eventNames().resetEvent, value, thisObject);
    vm.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebXRReferenceSpace_onreset, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRReferenceSpace>::set<setJSWebXRReferenceSpace_onresetSetter>(*lexicalGlobalObject, thisValue, encodedValue, attributeName);
}

static inline JSC::EncodedJSValue jsWebXRReferenceSpacePrototypeFunction_getOffsetReferenceSpaceBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSWebXRReferenceSpace>::ClassParameter castedThis)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto originOffsetConversionResult = convert<IDLInterface<WebXRRigidTransform>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "originOffset"_s, "XRReferenceSpace"_s, "getOffsetReferenceSpace"_s, "WebXRRigidTransform"_s); });
    if (UNLIKELY(originOffsetConversionResult.hasException(throwScope)))
       return encodedJSValue();
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJSNewlyCreated<IDLInterface<WebXRReferenceSpace>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, impl.getOffsetReferenceSpace(*originOffsetConversionResult.releaseReturnValue()))));
}

JSC_DEFINE_HOST_FUNCTION(jsWebXRReferenceSpacePrototypeFunction_getOffsetReferenceSpace, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSWebXRReferenceSpace>::call<jsWebXRReferenceSpacePrototypeFunction_getOffsetReferenceSpaceBody>(*lexicalGlobalObject, *callFrame, "getOffsetReferenceSpace");
}

JSC::GCClient::IsoSubspace* JSWebXRReferenceSpace::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSWebXRReferenceSpace, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForWebXRReferenceSpace.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForWebXRReferenceSpace = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForWebXRReferenceSpace.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForWebXRReferenceSpace = std::forward<decltype(space)>(space); }
    );
}

void JSWebXRReferenceSpace::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebXRReferenceSpace*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

WebXRReferenceSpace* JSWebXRReferenceSpace::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebXRReferenceSpace*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBXR)
