/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSWebXRRenderState.h"

#include "ActiveDOMObject.h"
#include "Document.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWindowBase.h"
#include "JSDOMWrapperCache.h"
#include "JSWebXRWebGLLayer.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

#if ENABLE(WEBXR_LAYERS)
#include "JSDOMConvertSequences.h"
#include "JSWebXRLayer.h"
#include <JavaScriptCore/JSArray.h>
#endif

namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderStateConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderState_depthNear);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderState_depthFar);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderState_inlineVerticalFieldOfView);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderState_baseLayer);
#if ENABLE(WEBXR_LAYERS)
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRRenderState_layers);
#endif

class JSWebXRRenderStatePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebXRRenderStatePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebXRRenderStatePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebXRRenderStatePrototype>(vm)) JSWebXRRenderStatePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRRenderStatePrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebXRRenderStatePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRRenderStatePrototype, JSWebXRRenderStatePrototype::Base);

using JSWebXRRenderStateDOMConstructor = JSDOMConstructorNotConstructable<JSWebXRRenderState>;

template<> const ClassInfo JSWebXRRenderStateDOMConstructor::s_info = { "XRRenderState"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRRenderStateDOMConstructor) };

template<> JSValue JSWebXRRenderStateDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSWebXRRenderStateDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRRenderState"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSWebXRRenderState::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 6> JSWebXRRenderStatePrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderStateConstructor, 0 } },
    HashTableValue { "depthNear"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderState_depthNear, 0 } },
    HashTableValue { "depthFar"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderState_depthFar, 0 } },
    HashTableValue { "inlineVerticalFieldOfView"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderState_inlineVerticalFieldOfView, 0 } },
    HashTableValue { "baseLayer"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderState_baseLayer, 0 } },
#if ENABLE(WEBXR_LAYERS)
    HashTableValue { "layers"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRRenderState_layers, 0 } },
#else
    HashTableValue { { }, 0, NoIntrinsic, { HashTableValue::End } },
#endif
};

const ClassInfo JSWebXRRenderStatePrototype::s_info = { "XRRenderState"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRRenderStatePrototype) };

void JSWebXRRenderStatePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebXRRenderState::info(), JSWebXRRenderStatePrototypeTableValues, *this);
    bool hasDisabledRuntimeProperties = false;
#if ENABLE(WEBXR_LAYERS)
    if (!(jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->isSecureContext() && (globalObject())->inherits<JSDOMWindowBase>() && downcast<Document>(jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext())->settingsValues().webXRLayersAPIEnabled)) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, "layers"_s);
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
    if (hasDisabledRuntimeProperties && structure()->isDictionary())
        flattenDictionaryObject(vm);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebXRRenderState::s_info = { "XRRenderState"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRRenderState) };

JSWebXRRenderState::JSWebXRRenderState(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebXRRenderState>&& impl)
    : JSDOMWrapper<WebXRRenderState>(structure, globalObject, WTFMove(impl))
{
}

static_assert(!std::is_base_of<ActiveDOMObject, WebXRRenderState>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSWebXRRenderState::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSWebXRRenderStatePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype());
    structure->setMayBePrototype(true);
    return JSWebXRRenderStatePrototype::create(vm, &globalObject, structure);
}

JSObject* JSWebXRRenderState::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebXRRenderState>(vm, globalObject);
}

JSValue JSWebXRRenderState::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebXRRenderStateDOMConstructor, DOMConstructorID::WebXRRenderState>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSWebXRRenderState::destroy(JSC::JSCell* cell)
{
    JSWebXRRenderState* thisObject = static_cast<JSWebXRRenderState*>(cell);
    thisObject->JSWebXRRenderState::~JSWebXRRenderState();
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderStateConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebXRRenderStatePrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebXRRenderState::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsWebXRRenderState_depthNearGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRRenderState& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.depthNear())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderState_depthNear, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRRenderState>::get<jsWebXRRenderState_depthNearGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsWebXRRenderState_depthFarGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRRenderState& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.depthFar())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderState_depthFar, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRRenderState>::get<jsWebXRRenderState_depthFarGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsWebXRRenderState_inlineVerticalFieldOfViewGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRRenderState& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLNullable<IDLDouble>>(lexicalGlobalObject, throwScope, impl.inlineVerticalFieldOfView())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderState_inlineVerticalFieldOfView, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRRenderState>::get<jsWebXRRenderState_inlineVerticalFieldOfViewGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsWebXRRenderState_baseLayerGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRRenderState& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLNullable<IDLInterface<WebXRWebGLLayer>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.baseLayer())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderState_baseLayer, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRRenderState>::get<jsWebXRRenderState_baseLayerGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

#if ENABLE(WEBXR_LAYERS)
static inline JSValue jsWebXRRenderState_layersGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRRenderState& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLFrozenArray<IDLInterface<WebXRLayer>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.layers())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRRenderState_layers, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRRenderState>::get<jsWebXRRenderState_layersGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

#endif

JSC::GCClient::IsoSubspace* JSWebXRRenderState::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSWebXRRenderState, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForWebXRRenderState.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForWebXRRenderState = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForWebXRRenderState.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForWebXRRenderState = std::forward<decltype(space)>(space); }
    );
}

void JSWebXRRenderState::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebXRRenderState*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

bool JSWebXRRenderStateOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, ASCIILiteral* reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSWebXRRenderStateOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebXRRenderState = static_cast<JSWebXRRenderState*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, jsWebXRRenderState->protectedWrapped().ptr(), jsWebXRRenderState);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebXRRenderState@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore16WebXRRenderStateE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, WebXRRenderState>, void>> static inline void verifyVTable(WebXRRenderState* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7WebXRRenderState@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore16WebXRRenderStateE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // WebXRRenderState has subclasses. If WebXRRenderState has subclasses that get passed
        // to toJS() we currently require WebXRRenderState you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebXRRenderState>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<WebXRRenderState>(impl.ptr());
#endif
    return createWrapper<WebXRRenderState>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebXRRenderState& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

WebXRRenderState* JSWebXRRenderState::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebXRRenderState*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBXR)
