/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSWebXRViewerPose.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "JSWebXRView.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebXRViewerPoseConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebXRViewerPose_views);

class JSWebXRViewerPosePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebXRViewerPosePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebXRViewerPosePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebXRViewerPosePrototype>(vm)) JSWebXRViewerPosePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRViewerPosePrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebXRViewerPosePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebXRViewerPosePrototype, JSWebXRViewerPosePrototype::Base);

using JSWebXRViewerPoseDOMConstructor = JSDOMConstructorNotConstructable<JSWebXRViewerPose>;

template<> const ClassInfo JSWebXRViewerPoseDOMConstructor::s_info = { "XRViewerPose"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRViewerPoseDOMConstructor) };

template<> JSValue JSWebXRViewerPoseDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSWebXRPose::getConstructor(vm, &globalObject);
}

template<> void JSWebXRViewerPoseDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRViewerPose"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSWebXRViewerPose::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 2> JSWebXRViewerPosePrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRViewerPoseConstructor, 0 } },
    HashTableValue { "views"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsWebXRViewerPose_views, 0 } },
};

const ClassInfo JSWebXRViewerPosePrototype::s_info = { "XRViewerPose"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRViewerPosePrototype) };

void JSWebXRViewerPosePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebXRViewerPose::info(), JSWebXRViewerPosePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebXRViewerPose::s_info = { "XRViewerPose"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebXRViewerPose) };

JSWebXRViewerPose::JSWebXRViewerPose(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebXRViewerPose>&& impl)
    : JSWebXRPose(structure, globalObject, WTFMove(impl))
{
}

Ref<WebXRViewerPose> JSWebXRViewerPose::protectedWrapped() const
{
    return wrapped();
}

static_assert(!std::is_base_of<ActiveDOMObject, WebXRViewerPose>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSWebXRViewerPose::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSWebXRViewerPosePrototype::createStructure(vm, &globalObject, JSWebXRPose::prototype(vm, globalObject));
    structure->setMayBePrototype(true);
    return JSWebXRViewerPosePrototype::create(vm, &globalObject, structure);
}

JSObject* JSWebXRViewerPose::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebXRViewerPose>(vm, globalObject);
}

JSValue JSWebXRViewerPose::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebXRViewerPoseDOMConstructor, DOMConstructorID::WebXRViewerPose>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRViewerPoseConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebXRViewerPosePrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebXRViewerPose::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsWebXRViewerPose_viewsGetter(JSGlobalObject& lexicalGlobalObject, JSWebXRViewerPose& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    if (JSValue cachedValue = thisObject.m_views.get())
        return cachedValue;
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFrozenArray<IDLInterface<WebXRView>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.views());
    RETURN_IF_EXCEPTION(throwScope, { });
    thisObject.m_views.set(JSC::getVM(&lexicalGlobalObject), &thisObject, result);
    return result;
}

JSC_DEFINE_CUSTOM_GETTER(jsWebXRViewerPose_views, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSWebXRViewerPose>::get<jsWebXRViewerPose_viewsGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

JSC::GCClient::IsoSubspace* JSWebXRViewerPose::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSWebXRViewerPose, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForWebXRViewerPose.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForWebXRViewerPose = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForWebXRViewerPose.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForWebXRViewerPose = std::forward<decltype(space)>(space); }
    );
}

template<typename Visitor>
void JSWebXRViewerPose::visitChildrenImpl(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSWebXRViewerPose*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    visitor.append(thisObject->m_views);
}

DEFINE_VISIT_CHILDREN(JSWebXRViewerPose);

void JSWebXRViewerPose::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebXRViewerPose*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebXRViewerPose@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15WebXRViewerPoseE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, WebXRViewerPose>, void>> static inline void verifyVTable(WebXRViewerPose* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7WebXRViewerPose@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore15WebXRViewerPoseE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // WebXRViewerPose has subclasses. If WebXRViewerPose has subclasses that get passed
        // to toJS() we currently require WebXRViewerPose you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebXRViewerPose>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<WebXRViewerPose>(impl.ptr());
#endif
    return createWrapper<WebXRViewerPose>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebXRViewerPose& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

WebXRViewerPose* JSWebXRViewerPose::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebXRViewerPose*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBXR)
