/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXREnvironmentBlendMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(XREnvironmentBlendMode enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 3> values {
        MAKE_STATIC_STRING_IMPL("opaque"),
        MAKE_STATIC_STRING_IMPL("additive"),
        MAKE_STATIC_STRING_IMPL("alpha-blend"),
    };
    static_assert(static_cast<size_t>(XREnvironmentBlendMode::Opaque) == 0, "XREnvironmentBlendMode::Opaque is not 0 as expected");
    static_assert(static_cast<size_t>(XREnvironmentBlendMode::Additive) == 1, "XREnvironmentBlendMode::Additive is not 1 as expected");
    static_assert(static_cast<size_t>(XREnvironmentBlendMode::AlphaBlend) == 2, "XREnvironmentBlendMode::AlphaBlend is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, XREnvironmentBlendMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<XREnvironmentBlendMode> parseEnumerationFromString<XREnvironmentBlendMode>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, XREnvironmentBlendMode>, 3> mappings {
        std::pair<ComparableASCIILiteral, XREnvironmentBlendMode> { "additive"_s, XREnvironmentBlendMode::Additive },
        std::pair<ComparableASCIILiteral, XREnvironmentBlendMode> { "alpha-blend"_s, XREnvironmentBlendMode::AlphaBlend },
        std::pair<ComparableASCIILiteral, XREnvironmentBlendMode> { "opaque"_s, XREnvironmentBlendMode::Opaque },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<XREnvironmentBlendMode> parseEnumeration<XREnvironmentBlendMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<XREnvironmentBlendMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<XREnvironmentBlendMode>()
{
    return "\"opaque\", \"additive\", \"alpha-blend\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEBXR)
