/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRHandedness.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(XRHandedness enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 3> values {
        MAKE_STATIC_STRING_IMPL("none"),
        MAKE_STATIC_STRING_IMPL("left"),
        MAKE_STATIC_STRING_IMPL("right"),
    };
    static_assert(static_cast<size_t>(XRHandedness::None) == 0, "XRHandedness::None is not 0 as expected");
    static_assert(static_cast<size_t>(XRHandedness::Left) == 1, "XRHandedness::Left is not 1 as expected");
    static_assert(static_cast<size_t>(XRHandedness::Right) == 2, "XRHandedness::Right is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, XRHandedness enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<XRHandedness> parseEnumerationFromString<XRHandedness>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, XRHandedness>, 3> mappings {
        std::pair<ComparableASCIILiteral, XRHandedness> { "left"_s, XRHandedness::Left },
        std::pair<ComparableASCIILiteral, XRHandedness> { "none"_s, XRHandedness::None },
        std::pair<ComparableASCIILiteral, XRHandedness> { "right"_s, XRHandedness::Right },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<XRHandedness> parseEnumeration<XRHandedness>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<XRHandedness>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<XRHandedness>()
{
    return "\"none\", \"left\", \"right\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEBXR)
