/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRInputSourceEvent.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertOptional.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "JSWebXRFrame.h"
#include "JSWebXRInputSource.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

#if ENABLE(WEBXR)

template<> ConversionResult<IDLDictionary<XRInputSourceEvent::Init>> convertDictionary<XRInputSourceEvent::Init>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    XRInputSourceEvent::Init result;
    JSValue bubblesValue;
    if (isNullOrUndefined)
        bubblesValue = jsUndefined();
    else {
        bubblesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bubbles"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto bubblesConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, bubblesValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(bubblesConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.bubbles = bubblesConversionResult.releaseReturnValue();
    JSValue cancelableValue;
    if (isNullOrUndefined)
        cancelableValue = jsUndefined();
    else {
        cancelableValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "cancelable"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto cancelableConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, cancelableValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(cancelableConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.cancelable = cancelableConversionResult.releaseReturnValue();
    JSValue composedValue;
    if (isNullOrUndefined)
        composedValue = jsUndefined();
    else {
        composedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "composed"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto composedConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, composedValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(composedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.composed = composedConversionResult.releaseReturnValue();
    JSValue frameValue;
    if (isNullOrUndefined)
        frameValue = jsUndefined();
    else {
        frameValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "frame"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (frameValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "frame"_s, "XRInputSourceEventInit"_s, "WebXRFrame"_s);
        return ConversionResultException { };
    }
    auto frameConversionResult = convert<IDLInterface<WebXRFrame>>(lexicalGlobalObject, frameValue);
    if (UNLIKELY(frameConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.frame = frameConversionResult.releaseReturnValue();
    JSValue inputSourceValue;
    if (isNullOrUndefined)
        inputSourceValue = jsUndefined();
    else {
        inputSourceValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "inputSource"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (inputSourceValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "inputSource"_s, "XRInputSourceEventInit"_s, "WebXRInputSource"_s);
        return ConversionResultException { };
    }
    auto inputSourceConversionResult = convert<IDLInterface<WebXRInputSource>>(lexicalGlobalObject, inputSourceValue);
    if (UNLIKELY(inputSourceConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.inputSource = inputSourceConversionResult.releaseReturnValue();
    return result;
}

#endif

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourceEventConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourceEvent_frame);
static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourceEvent_inputSource);

class JSXRInputSourceEventPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSXRInputSourceEventPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSXRInputSourceEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSXRInputSourceEventPrototype>(vm)) JSXRInputSourceEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSXRInputSourceEventPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSXRInputSourceEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSXRInputSourceEventPrototype, JSXRInputSourceEventPrototype::Base);

using JSXRInputSourceEventDOMConstructor = JSDOMConstructor<JSXRInputSourceEvent>;

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSXRInputSourceEventDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSXRInputSourceEventDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto typeConversionResult = convert<IDLAtomStringAdaptor<IDLDOMString>>(*lexicalGlobalObject, argument0.value());
    if (UNLIKELY(typeConversionResult.hasException(throwScope)))
       return encodedJSValue();
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto eventInitDictConversionResult = convert<IDLDictionary<XRInputSourceEvent::Init>>(*lexicalGlobalObject, argument1.value());
    if (UNLIKELY(eventInitDictConversionResult.hasException(throwScope)))
       return encodedJSValue();
    auto object = XRInputSourceEvent::create(typeConversionResult.releaseReturnValue(), eventInitDictConversionResult.releaseReturnValue());
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<XRInputSourceEvent>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<XRInputSourceEvent>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSXRInputSourceEventDOMConstructorConstruct, JSXRInputSourceEventDOMConstructor::construct);

template<> const ClassInfo JSXRInputSourceEventDOMConstructor::s_info = { "XRInputSourceEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourceEventDOMConstructor) };

template<> JSValue JSXRInputSourceEventDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEvent::getConstructor(vm, &globalObject);
}

template<> void JSXRInputSourceEventDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(2), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRInputSourceEvent"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSXRInputSourceEvent::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 3> JSXRInputSourceEventPrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourceEventConstructor, 0 } },
    HashTableValue { "frame"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourceEvent_frame, 0 } },
    HashTableValue { "inputSource"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourceEvent_inputSource, 0 } },
};

const ClassInfo JSXRInputSourceEventPrototype::s_info = { "XRInputSourceEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourceEventPrototype) };

void JSXRInputSourceEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSXRInputSourceEvent::info(), JSXRInputSourceEventPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSXRInputSourceEvent::s_info = { "XRInputSourceEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourceEvent) };

JSXRInputSourceEvent::JSXRInputSourceEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<XRInputSourceEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

Ref<XRInputSourceEvent> JSXRInputSourceEvent::protectedWrapped() const
{
    return wrapped();
}

static_assert(!std::is_base_of<ActiveDOMObject, XRInputSourceEvent>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSXRInputSourceEvent::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSXRInputSourceEventPrototype::createStructure(vm, &globalObject, JSEvent::prototype(vm, globalObject));
    structure->setMayBePrototype(true);
    return JSXRInputSourceEventPrototype::create(vm, &globalObject, structure);
}

JSObject* JSXRInputSourceEvent::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSXRInputSourceEvent>(vm, globalObject);
}

JSValue JSXRInputSourceEvent::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSXRInputSourceEventDOMConstructor, DOMConstructorID::XRInputSourceEvent>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourceEventConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSXRInputSourceEventPrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSXRInputSourceEvent::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsXRInputSourceEvent_frameGetter(JSGlobalObject& lexicalGlobalObject, JSXRInputSourceEvent& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<WebXRFrame>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.frame())));
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourceEvent_frame, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSXRInputSourceEvent>::get<jsXRInputSourceEvent_frameGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsXRInputSourceEvent_inputSourceGetter(JSGlobalObject& lexicalGlobalObject, JSXRInputSourceEvent& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<WebXRInputSource>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.inputSource())));
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourceEvent_inputSource, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSXRInputSourceEvent>::get<jsXRInputSourceEvent_inputSourceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

JSC::GCClient::IsoSubspace* JSXRInputSourceEvent::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSXRInputSourceEvent, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForXRInputSourceEvent.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForXRInputSourceEvent = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForXRInputSourceEvent.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForXRInputSourceEvent = std::forward<decltype(space)>(space); }
    );
}

void JSXRInputSourceEvent::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSXRInputSourceEvent*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7XRInputSourceEvent@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18XRInputSourceEventE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, XRInputSourceEvent>, void>> static inline void verifyVTable(XRInputSourceEvent* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7XRInputSourceEvent@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore18XRInputSourceEventE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // XRInputSourceEvent has subclasses. If XRInputSourceEvent has subclasses that get passed
        // to toJS() we currently require XRInputSourceEvent you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<XRInputSourceEvent>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<XRInputSourceEvent>(impl.ptr());
#endif
    return createWrapper<XRInputSourceEvent>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, XRInputSourceEvent& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEBXR)
