/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRInputSourcesChangeEvent.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertOptional.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "JSWebXRInputSource.h"
#include "JSWebXRSession.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

#if ENABLE(WEBXR)

template<> ConversionResult<IDLDictionary<XRInputSourcesChangeEvent::Init>> convertDictionary<XRInputSourcesChangeEvent::Init>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    XRInputSourcesChangeEvent::Init result;
    JSValue bubblesValue;
    if (isNullOrUndefined)
        bubblesValue = jsUndefined();
    else {
        bubblesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bubbles"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto bubblesConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, bubblesValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(bubblesConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.bubbles = bubblesConversionResult.releaseReturnValue();
    JSValue cancelableValue;
    if (isNullOrUndefined)
        cancelableValue = jsUndefined();
    else {
        cancelableValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "cancelable"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto cancelableConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, cancelableValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(cancelableConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.cancelable = cancelableConversionResult.releaseReturnValue();
    JSValue composedValue;
    if (isNullOrUndefined)
        composedValue = jsUndefined();
    else {
        composedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "composed"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto composedConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, composedValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(composedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.composed = composedConversionResult.releaseReturnValue();
    JSValue addedValue;
    if (isNullOrUndefined)
        addedValue = jsUndefined();
    else {
        addedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "added"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (addedValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "added"_s, "XRInputSourcesChangeEventInit"_s, "FrozenArray"_s);
        return ConversionResultException { };
    }
    auto addedConversionResult = convert<IDLFrozenArray<IDLInterface<WebXRInputSource>>>(lexicalGlobalObject, addedValue);
    if (UNLIKELY(addedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.added = addedConversionResult.releaseReturnValue();
    JSValue removedValue;
    if (isNullOrUndefined)
        removedValue = jsUndefined();
    else {
        removedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "removed"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (removedValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "removed"_s, "XRInputSourcesChangeEventInit"_s, "FrozenArray"_s);
        return ConversionResultException { };
    }
    auto removedConversionResult = convert<IDLFrozenArray<IDLInterface<WebXRInputSource>>>(lexicalGlobalObject, removedValue);
    if (UNLIKELY(removedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.removed = removedConversionResult.releaseReturnValue();
    JSValue sessionValue;
    if (isNullOrUndefined)
        sessionValue = jsUndefined();
    else {
        sessionValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "session"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (sessionValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "session"_s, "XRInputSourcesChangeEventInit"_s, "WebXRSession"_s);
        return ConversionResultException { };
    }
    auto sessionConversionResult = convert<IDLInterface<WebXRSession>>(lexicalGlobalObject, sessionValue);
    if (UNLIKELY(sessionConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.session = sessionConversionResult.releaseReturnValue();
    return result;
}

#endif

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourcesChangeEventConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_session);
static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_added);
static JSC_DECLARE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_removed);

class JSXRInputSourcesChangeEventPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSXRInputSourcesChangeEventPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSXRInputSourcesChangeEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSXRInputSourcesChangeEventPrototype>(vm)) JSXRInputSourcesChangeEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSXRInputSourcesChangeEventPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSXRInputSourcesChangeEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSXRInputSourcesChangeEventPrototype, JSXRInputSourcesChangeEventPrototype::Base);

using JSXRInputSourcesChangeEventDOMConstructor = JSDOMConstructor<JSXRInputSourcesChangeEvent>;

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSXRInputSourcesChangeEventDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSXRInputSourcesChangeEventDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto typeConversionResult = convert<IDLAtomStringAdaptor<IDLDOMString>>(*lexicalGlobalObject, argument0.value());
    if (UNLIKELY(typeConversionResult.hasException(throwScope)))
       return encodedJSValue();
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto eventInitDictConversionResult = convert<IDLDictionary<XRInputSourcesChangeEvent::Init>>(*lexicalGlobalObject, argument1.value());
    if (UNLIKELY(eventInitDictConversionResult.hasException(throwScope)))
       return encodedJSValue();
    auto object = XRInputSourcesChangeEvent::create(typeConversionResult.releaseReturnValue(), eventInitDictConversionResult.releaseReturnValue());
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<XRInputSourcesChangeEvent>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<XRInputSourcesChangeEvent>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSXRInputSourcesChangeEventDOMConstructorConstruct, JSXRInputSourcesChangeEventDOMConstructor::construct);

template<> const ClassInfo JSXRInputSourcesChangeEventDOMConstructor::s_info = { "XRInputSourcesChangeEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourcesChangeEventDOMConstructor) };

template<> JSValue JSXRInputSourcesChangeEventDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEvent::getConstructor(vm, &globalObject);
}

template<> void JSXRInputSourcesChangeEventDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(2), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "XRInputSourcesChangeEvent"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSXRInputSourcesChangeEvent::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 4> JSXRInputSourcesChangeEventPrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourcesChangeEventConstructor, 0 } },
    HashTableValue { "session"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourcesChangeEvent_session, 0 } },
    HashTableValue { "added"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourcesChangeEvent_added, 0 } },
    HashTableValue { "removed"_s, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute, NoIntrinsic, { HashTableValue::GetterSetterType, jsXRInputSourcesChangeEvent_removed, 0 } },
};

const ClassInfo JSXRInputSourcesChangeEventPrototype::s_info = { "XRInputSourcesChangeEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourcesChangeEventPrototype) };

void JSXRInputSourcesChangeEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSXRInputSourcesChangeEvent::info(), JSXRInputSourcesChangeEventPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSXRInputSourcesChangeEvent::s_info = { "XRInputSourcesChangeEvent"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSXRInputSourcesChangeEvent) };

JSXRInputSourcesChangeEvent::JSXRInputSourcesChangeEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<XRInputSourcesChangeEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

Ref<XRInputSourcesChangeEvent> JSXRInputSourcesChangeEvent::protectedWrapped() const
{
    return wrapped();
}

static_assert(!std::is_base_of<ActiveDOMObject, XRInputSourcesChangeEvent>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSXRInputSourcesChangeEvent::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSXRInputSourcesChangeEventPrototype::createStructure(vm, &globalObject, JSEvent::prototype(vm, globalObject));
    structure->setMayBePrototype(true);
    return JSXRInputSourcesChangeEventPrototype::create(vm, &globalObject, structure);
}

JSObject* JSXRInputSourcesChangeEvent::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSXRInputSourcesChangeEvent>(vm, globalObject);
}

JSValue JSXRInputSourcesChangeEvent::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSXRInputSourcesChangeEventDOMConstructor, DOMConstructorID::XRInputSourcesChangeEvent>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourcesChangeEventConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSXRInputSourcesChangeEventPrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSXRInputSourcesChangeEvent::getConstructor(vm, prototype->globalObject()));
}

static inline JSValue jsXRInputSourcesChangeEvent_sessionGetter(JSGlobalObject& lexicalGlobalObject, JSXRInputSourcesChangeEvent& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<WebXRSession>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.session())));
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_session, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSXRInputSourcesChangeEvent>::get<jsXRInputSourcesChangeEvent_sessionGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsXRInputSourcesChangeEvent_addedGetter(JSGlobalObject& lexicalGlobalObject, JSXRInputSourcesChangeEvent& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    if (JSValue cachedValue = thisObject.m_added.get())
        return cachedValue;
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFrozenArray<IDLInterface<WebXRInputSource>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.added());
    RETURN_IF_EXCEPTION(throwScope, { });
    thisObject.m_added.set(JSC::getVM(&lexicalGlobalObject), &thisObject, result);
    return result;
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_added, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSXRInputSourcesChangeEvent>::get<jsXRInputSourcesChangeEvent_addedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

static inline JSValue jsXRInputSourcesChangeEvent_removedGetter(JSGlobalObject& lexicalGlobalObject, JSXRInputSourcesChangeEvent& thisObject)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    if (JSValue cachedValue = thisObject.m_removed.get())
        return cachedValue;
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFrozenArray<IDLInterface<WebXRInputSource>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.removed());
    RETURN_IF_EXCEPTION(throwScope, { });
    thisObject.m_removed.set(JSC::getVM(&lexicalGlobalObject), &thisObject, result);
    return result;
}

JSC_DEFINE_CUSTOM_GETTER(jsXRInputSourcesChangeEvent_removed, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName attributeName))
{
    return IDLAttribute<JSXRInputSourcesChangeEvent>::get<jsXRInputSourcesChangeEvent_removedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, attributeName);
}

JSC::GCClient::IsoSubspace* JSXRInputSourcesChangeEvent::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSXRInputSourcesChangeEvent, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForXRInputSourcesChangeEvent.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForXRInputSourcesChangeEvent = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForXRInputSourcesChangeEvent.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForXRInputSourcesChangeEvent = std::forward<decltype(space)>(space); }
    );
}

template<typename Visitor>
void JSXRInputSourcesChangeEvent::visitChildrenImpl(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSXRInputSourcesChangeEvent*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    visitor.append(thisObject->m_added);
    visitor.append(thisObject->m_removed);
}

DEFINE_VISIT_CHILDREN(JSXRInputSourcesChangeEvent);

void JSXRInputSourcesChangeEvent::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSXRInputSourcesChangeEvent*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7XRInputSourcesChangeEvent@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore25XRInputSourcesChangeEventE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, XRInputSourcesChangeEvent>, void>> static inline void verifyVTable(XRInputSourcesChangeEvent* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7XRInputSourcesChangeEvent@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore25XRInputSourcesChangeEventE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // XRInputSourcesChangeEvent has subclasses. If XRInputSourcesChangeEvent has subclasses that get passed
        // to toJS() we currently require XRInputSourcesChangeEvent you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<XRInputSourcesChangeEvent>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<XRInputSourcesChangeEvent>(impl.ptr());
#endif
    return createWrapper<XRInputSourcesChangeEvent>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, XRInputSourcesChangeEvent& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEBXR)
