/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRReferenceSpaceType.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(XRReferenceSpaceType enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 5> values {
        MAKE_STATIC_STRING_IMPL("viewer"),
        MAKE_STATIC_STRING_IMPL("local"),
        MAKE_STATIC_STRING_IMPL("local-floor"),
        MAKE_STATIC_STRING_IMPL("bounded-floor"),
        MAKE_STATIC_STRING_IMPL("unbounded"),
    };
    static_assert(static_cast<size_t>(XRReferenceSpaceType::Viewer) == 0, "XRReferenceSpaceType::Viewer is not 0 as expected");
    static_assert(static_cast<size_t>(XRReferenceSpaceType::Local) == 1, "XRReferenceSpaceType::Local is not 1 as expected");
    static_assert(static_cast<size_t>(XRReferenceSpaceType::LocalFloor) == 2, "XRReferenceSpaceType::LocalFloor is not 2 as expected");
    static_assert(static_cast<size_t>(XRReferenceSpaceType::BoundedFloor) == 3, "XRReferenceSpaceType::BoundedFloor is not 3 as expected");
    static_assert(static_cast<size_t>(XRReferenceSpaceType::Unbounded) == 4, "XRReferenceSpaceType::Unbounded is not 4 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, XRReferenceSpaceType enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<XRReferenceSpaceType> parseEnumerationFromString<XRReferenceSpaceType>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, XRReferenceSpaceType>, 5> mappings {
        std::pair<ComparableASCIILiteral, XRReferenceSpaceType> { "bounded-floor"_s, XRReferenceSpaceType::BoundedFloor },
        std::pair<ComparableASCIILiteral, XRReferenceSpaceType> { "local"_s, XRReferenceSpaceType::Local },
        std::pair<ComparableASCIILiteral, XRReferenceSpaceType> { "local-floor"_s, XRReferenceSpaceType::LocalFloor },
        std::pair<ComparableASCIILiteral, XRReferenceSpaceType> { "unbounded"_s, XRReferenceSpaceType::Unbounded },
        std::pair<ComparableASCIILiteral, XRReferenceSpaceType> { "viewer"_s, XRReferenceSpaceType::Viewer },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<XRReferenceSpaceType> parseEnumeration<XRReferenceSpaceType>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<XRReferenceSpaceType>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<XRReferenceSpaceType>()
{
    return "\"viewer\", \"local\", \"local-floor\", \"bounded-floor\", \"unbounded\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEBXR)
