/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRSessionInit.h"

#include "JSDOMConvertAny.h"
#include "JSDOMConvertSequences.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

#if ENABLE(WEBXR)

template<> ConversionResult<IDLDictionary<XRSessionInit>> convertDictionary<XRSessionInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    XRSessionInit result;
    JSValue optionalFeaturesValue;
    if (isNullOrUndefined)
        optionalFeaturesValue = jsUndefined();
    else {
        optionalFeaturesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "optionalFeatures"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!optionalFeaturesValue.isUndefined()) {
        auto optionalFeaturesConversionResult = convert<IDLSequence<IDLAny>>(lexicalGlobalObject, optionalFeaturesValue);
        if (UNLIKELY(optionalFeaturesConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.optionalFeatures = optionalFeaturesConversionResult.releaseReturnValue();
    }
    JSValue requiredFeaturesValue;
    if (isNullOrUndefined)
        requiredFeaturesValue = jsUndefined();
    else {
        requiredFeaturesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "requiredFeatures"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!requiredFeaturesValue.isUndefined()) {
        auto requiredFeaturesConversionResult = convert<IDLSequence<IDLAny>>(lexicalGlobalObject, requiredFeaturesValue);
        if (UNLIKELY(requiredFeaturesConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.requiredFeatures = requiredFeaturesConversionResult.releaseReturnValue();
    }
    return result;
}

#endif

} // namespace WebCore


#endif // ENABLE(WEBXR)
