/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRSessionMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(XRSessionMode enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 3> values {
        MAKE_STATIC_STRING_IMPL("inline"),
        MAKE_STATIC_STRING_IMPL("immersive-vr"),
        MAKE_STATIC_STRING_IMPL("immersive-ar"),
    };
    static_assert(static_cast<size_t>(XRSessionMode::Inline) == 0, "XRSessionMode::Inline is not 0 as expected");
    static_assert(static_cast<size_t>(XRSessionMode::ImmersiveVr) == 1, "XRSessionMode::ImmersiveVr is not 1 as expected");
    static_assert(static_cast<size_t>(XRSessionMode::ImmersiveAr) == 2, "XRSessionMode::ImmersiveAr is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, XRSessionMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<XRSessionMode> parseEnumerationFromString<XRSessionMode>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, XRSessionMode>, 3> mappings {
        std::pair<ComparableASCIILiteral, XRSessionMode> { "immersive-ar"_s, XRSessionMode::ImmersiveAr },
        std::pair<ComparableASCIILiteral, XRSessionMode> { "immersive-vr"_s, XRSessionMode::ImmersiveVr },
        std::pair<ComparableASCIILiteral, XRSessionMode> { "inline"_s, XRSessionMode::Inline },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<XRSessionMode> parseEnumeration<XRSessionMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<XRSessionMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<XRSessionMode>()
{
    return "\"inline\", \"immersive-vr\", \"immersive-ar\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEBXR)
