/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBXR)

#include "JSXRTargetRayMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(XRTargetRayMode enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 4> values {
        MAKE_STATIC_STRING_IMPL("gaze"),
        MAKE_STATIC_STRING_IMPL("tracked-pointer"),
        MAKE_STATIC_STRING_IMPL("screen"),
        MAKE_STATIC_STRING_IMPL("transient-pointer"),
    };
    static_assert(static_cast<size_t>(XRTargetRayMode::Gaze) == 0, "XRTargetRayMode::Gaze is not 0 as expected");
    static_assert(static_cast<size_t>(XRTargetRayMode::TrackedPointer) == 1, "XRTargetRayMode::TrackedPointer is not 1 as expected");
    static_assert(static_cast<size_t>(XRTargetRayMode::Screen) == 2, "XRTargetRayMode::Screen is not 2 as expected");
    static_assert(static_cast<size_t>(XRTargetRayMode::TransientPointer) == 3, "XRTargetRayMode::TransientPointer is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, XRTargetRayMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<XRTargetRayMode> parseEnumerationFromString<XRTargetRayMode>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, XRTargetRayMode>, 4> mappings {
        std::pair<ComparableASCIILiteral, XRTargetRayMode> { "gaze"_s, XRTargetRayMode::Gaze },
        std::pair<ComparableASCIILiteral, XRTargetRayMode> { "screen"_s, XRTargetRayMode::Screen },
        std::pair<ComparableASCIILiteral, XRTargetRayMode> { "tracked-pointer"_s, XRTargetRayMode::TrackedPointer },
        std::pair<ComparableASCIILiteral, XRTargetRayMode> { "transient-pointer"_s, XRTargetRayMode::TransientPointer },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<XRTargetRayMode> parseEnumeration<XRTargetRayMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<XRTargetRayMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<XRTargetRayMode>()
{
    return "\"gaze\", \"tracked-pointer\", \"screen\", \"transient-pointer\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEBXR)
